#import "StupidBug.h"


@implementation StupidBug
+ create: aZone
{
   StupidBug* stupidBug = [super create: aZone];

   stupidBug->myWorld = nil;

   return stupidBug;
}



/////////////////////////////////
//
// setWorld
//
////////////////////////////////
- setWorld: (id <Grid2d>) aWorld
{
   myWorld = aWorld;
   worldSizeX = [myWorld getSizeX];
   worldSizeY = [myWorld getSizeY];
   return self;
}
	


/////////////////////////////////////////
//
// setRandPosition
//
////////////////////////////////////////
- setRandPosition
{
    if(myWorld == nil)
    {
       fprintf(stderr, "ERROR: StupidBug >>>> setRandPosition >>>> myWorld is nil\n");
       fflush(0);
       exit(1);
    }    
 
    do 
    {
        myX = [uniformIntRand getIntegerWithMin: 0 withMax: worldSizeX - 1];
        myY = [uniformIntRand getIntegerWithMin: 0 withMax: worldSizeY - 1];

    } while ([myWorld getObjectAtX: myX Y: myY] != nil);

    [myWorld putObject: self 
                   atX: myX 
                     Y: myY];

    return self;
}


//////////////////////////////////////
//
// drawSelfOn
//
//////////////////////////////////////
- drawSelfOn: (id <Raster>) aRaster 
{
   [aRaster drawPointX: myX Y: myY Color: (Color) 1];
   return self;
}

	

////////////////////////////////////
//
// move
//
////////////////////////////////////
- move 
{
   int moveDistance = 4;
   int newX, newY;

   do 
   {
       newX = [self xnorm: myX + [uniformIntRand getIntegerWithMin: -moveDistance withMax: moveDistance]];
       newY = [self ynorm: myY + [uniformIntRand getIntegerWithMin: -moveDistance withMax: moveDistance]];

   } while([myWorld getObjectAtX: newX Y:newY] != nil);
	
   [myWorld putObject: nil atX: myX Y: myY];

   myX = newX;
   myY = newY;

   [myWorld putObject: self atX: myX Y: myY];

   return self;
}

//
// These are stolen directly from Repast's toroid space
//
- (int) xnorm: (int) x
{
    if((x > worldSizeX - 1) || (x < 0)) 
    {
        while(x < 0)
        {
            x += worldSizeX;
        }

        return x % worldSizeX;
    }

    return x;
}

- (int) ynorm: (int) y
{
    if((y > worldSizeY - 1) || (y < 0)) 
    {
           while(y < 0) 
           {
               y += worldSizeY;
           }

           return y % worldSizeY;
    }

    return y;
}

@end
