#import "StupidModelSwarm.h"


@implementation StupidModelSwarm

+ create: (id) aZone 
{
  StupidModelSwarm* obj = [super create: aZone];
  return obj;
}

////////////////////////////////////
//
// buildObjects
//
///////////////////////////////////
- buildObjects 
{
  int i;

  //
  // allow our parent class to build anything.
  //
  [super buildObjects];

  //
  // Create a modelZone in which to manage our objects
  //
  modelZone = [Zone create: [self getZone]];

  //
  // Now set up the grid used to represent agent position
  //
  world = [Grid2d create: modelZone setSizeX: 100 Y: 100];

  //
  // Create a list of the stupidBugs
  //
  bugList = [List create: modelZone];
  
  //
  // Make some agents
  // The bugs put themselves on the space.
  //
  for(i = 0; i < 100; i++) 
  {
      StupidBug* stupidBug = nil;

      stupidBug = [StupidBug create: modelZone];
      [stupidBug setWorld: world];
      [stupidBug setRandPosition];
 
      [bugList addLast: stupidBug];
  }

  return self;
 
}
	

 

/////////////////////////////////////
//
// buildActions
//
/////////////////////////////////////
- buildActions 
{
  //fprintf(stdout, "StupidModelSwarm >>>> buildActions >>>> BEGIN\n");

  [super buildActions];

  //
  // First, create an action group for agent actions
  //
  bugActions = [ActionGroup create: modelZone];

  //
  // Next, create the "move" action for bugs
  // Include the StupidBug interface (i.e. StupidBug.h) in StupidModelSwarm.h
  //
  [bugActions createActionForEach: bugList message: M(move)];

  //
  // Then we create a schedule and put the 
  // action group(s) on it. 	      
  //
  modelSchedule = [Schedule createBegin: modelZone];
  [modelSchedule setRepeatInterval: 1];
  modelSchedule = [modelSchedule createEnd];
  [modelSchedule at: 0 createAction: bugActions];

  //fprintf(stdout, "StupidModelSwarm >>>> buildActions >>>> END\n");

  return self;
}

- activateIn:  swarmContext 
{
  //
  // First, activate ourselves via the superclass
  // activateIn: method.  Just pass along the context: the
  // activity library does the right thing.
  //
  [super activateIn: swarmContext];

  //
  // Now activate our own schedule.
  //
  [modelSchedule activateIn: self];

  //
  // Finally, return our activity.
  //
  return [self getSwarmActivity];
}


///////////////////////////////
//
// getBugList
//
//////////////////////////////
- (id <List>) getBugList
{
    return bugList;
}


/////////////////////////////
//
// getWorld
//
////////////////////////////
- getWorld
{
   return world;
}
@end
