#import <objectbase.h>
#import <objectbase/Swarm.h>
#import <simtools.h>  //For QSort
#import <space.h>
#import <analysis.h>

#import "HabitatCell.h"
#import "StupidBug.h"


@interface StupidModelSwarm: Swarm
{
  @private
     id <Zone> modelZone;

     id <ActionGroup> updateActions;
     id <ActionGroup> bugActions;
     id <ActionGroup> cellActions;
     id <ActionGroup> cleanupActions;
     id <Schedule> modelSchedule;
     id <List> cellList;
     id <List> bugList;
     id <List> newBugList;
     id <List> deadBugList;

     id <Grid2d> cellWorld;
     id <Grid2d> bugWorld;
     double cellInitialFoodAvailability;
     double cellMaxFoodProductionRate;
     double bugSurvivalProbability;

     int numberOfInitialBugs;
     double bugInitSize;
     double bugMaxConsumptionRate;

     id <Averager> bugSizeAverager;
     FILE* bsFilePtr;

}

+ create: aZone;
- buildObjects;
- buildActions;
- activateIn: swarmContext;
- (BOOL) saysToStop;
- outputBugSize;
- addBug: aBug;
- removeBug: aBug;
- addAndRemoveBugs;

- (id <Zone>) getModelZone;

- (id <Grid2d>) getCellWorld;
- (id <Grid2d>) getBugWorld;
- (id <List>) getBugList;
- (id <List>) getCellList;

- (double) getCellInitialFoodAvailability;
- (double) getCellMaxFoodProductionRate;
- (double) getBugInitSize;
- (double) getBugMaxConsumptionRate;
- (double) getBugSurvivalProbability;


@end
