#import "StupidModelSwarm.h"
#import "HabitatCell.h"

@implementation HabitatCell 

+ create: aZone
{
    HabitatCell* habitatCell = [super create: aZone];

    habitatCell->myX = -1;
    habitatCell->myY = -1;
    habitatCell->cellFoodAvailable = -1.0;
    habitatCell->FOOD_FOR_MAX_INTENSITY = 0.5;

    return habitatCell;
}

- setStupidModelSwarm: aStupidModelSwarm
{
    stupidModelSwarm = aStupidModelSwarm;
    return self;
}

- setCellFoodAvailable: (double) aCellFoodAvailable
{
   cellFoodAvailable = aCellFoodAvailable;
   return self;
}

- (double) getCellFoodAvailable
{
    return cellFoodAvailable;
}

- setCellFoodProductionRate: (double) aFoodProductionRate
{
    cellFoodProductionRate = aFoodProductionRate;
    return self;
}

- (double) getFoodProductionRate
{
    return cellFoodProductionRate;
}

- setMyX: (int) anX
{
   myX = anX;
   return self;
}

- (int) getMyX
{
    return myX;
}

- setMyY: (int)  aY 
{
   myY = aY;
   return self;
}

- (int) getMyY
{
    return myY;
}
	



	
////////////////////////////////////
//
// drawSelfOn
//
// Starting in version 15, cells color themselves
// by their food availability
// Green shades are colors 64-127.
//
////////////////////////////////////
- drawSelfOn: (id <Raster>)  aRaster 
{
  Color drawColor;

  double foodColor = 63*(cellFoodAvailable/FOOD_FOR_MAX_INTENSITY);

  drawColor = (Color) (foodColor < 63) ? foodColor : 63;  

  drawColor = (Color) drawColor + 64;

  [aRaster drawPointX: myX Y: myY Color: drawColor];

  return self;
}
///////////////////////////////////
//
// growFood
//
// Modified for version 15:
//
////////////////////////////////////
- growFood
{
   cellFoodAvailable += cellFoodProductionRate;
   return self;
}



@end

