#import <objectbase.h>
#import <objectbase/Swarm.h>
#import <simtools.h>  //For QSort
#import <space.h>
#import <analysis.h>
#import <stdio.h>

#import "HabitatCell.h"
#import "StupidBug.h"
#import "StupidPredator.h"


@interface StupidModelSwarm: Swarm
{
  @private
     id <Zone> modelZone;

     id <ActionGroup> updateActions;
     id <ActionGroup> bugActions;
     id <ActionGroup> predatorActions;
     id <ActionGroup> cellActions;
     id <ActionGroup> cleanupActions;
     id <Schedule> modelSchedule;
     id <List> cellList;
     id <List> bugList;
     id <List> predList;
     id <List> newBugList;
     id <List> deadBugList;

     id <Grid2d> cellWorld;
     id <Grid2d> bugWorld;
     id <Grid2d> predWorld;

     char* cellFileName;
     int worldMaxX;
     int worldMaxY;

     double cellInitialFoodAvailability;
     double cellMaxFoodProductionRate;
     double bugSurvivalProbability;

     int numberOfInitialBugs;
     double initialBugSizeMean;
     double initialBugSizeSD;
     double bugMaxConsumptionRate;

     id <Averager> bugSizeAverager;
     FILE* bsFilePtr;

     id <NormalDist> bugInitSizeDist; 

}

+ create: aZone;
- buildObjects;
- buildCells;
- buildActions;
- activateIn: swarmContext;
- (BOOL) saysToStop;
- outputBugSize;
- addBug: aBug;
- removeBug: aBug;
- addAndRemoveBugs;

- (id <Zone>) getModelZone;

- (id <Grid2d>) getCellWorld;
- (id <Grid2d>) getBugWorld;
- (id <Grid2d>) getPredWorld;
- (id <List>) getBugList;
- (id <List>) getCellList;
- (id <List>) getPredList;

- (double) getCellInitialFoodAvailability;
- (double) getBugMaxConsumptionRate;
- (double) getBugSurvivalProbability;


@end
