#import "StupidBug.h"


@implementation StupidBug
+ create: aZone
{
   StupidBug* stupidBug = [super create: aZone];

   stupidBug->myWorld = nil;
   stupidBug->mySize = 1;

   return stupidBug;
}




/////////////////////////////////
//
// setWorld
//
////////////////////////////////
- setWorld: (id <Grid2d>) aWorld
{
   myWorld = aWorld;
   worldSizeX = [myWorld getSizeX];
   worldSizeY = [myWorld getSizeY];
   return self;
}
	


/////////////////////////////////////////
//
// setRandPosition
//
////////////////////////////////////////
- setRandPosition
{
    if(myWorld == nil)
    {
       fprintf(stderr, "ERROR: StupidBug >>>> setRandPosition >>>> myWorld is nil\n");
       fflush(0);
       exit(1);
    }    
 
    do 
    {
        myX = [uniformIntRand getIntegerWithMin: 0 withMax: worldSizeX - 1];
        myY = [uniformIntRand getIntegerWithMin: 0 withMax: worldSizeY - 1];

    } while ([myWorld getObjectAtX: myX Y: myY] != nil);

    [myWorld putObject: self 
                   atX: myX 
                     Y: myY];

    return self;
}


/////////////////////////////////////////////////////
//
// drawSelfOn
//
// Starting with Version 2, the intensity of red
// is proportional to bug size. We must set a size
// at which redness is maximum
// In the observer swarm, the color map is given
// red shades from 0 to 63.
//
/////////////////////////////////////////////////////
- drawSelfOn: (id <Raster>) aRaster 
{
   int maxDrawSize = 10;
   int drawSizeRatio = (int) (63*(mySize/maxDrawSize));
   Color drawColor = (Color) (drawSizeRatio < 63) ? drawSizeRatio : 63;

   [aRaster drawPointX: myX Y: myY Color: drawColor];
		
   return self;
}

	

////////////////////////////////////
//
// move
//
////////////////////////////////////
- move 
{
   int moveDistance = 4;
   int newX, newY;

   do 
   {
       newX = [self xnorm: myX + [uniformIntRand getIntegerWithMin: -moveDistance withMax: moveDistance]];
       newY = [self ynorm: myY + [uniformIntRand getIntegerWithMin: -moveDistance withMax: moveDistance]];

   } while([myWorld getObjectAtX: newX Y:newY] != nil);
	
   [myWorld putObject: nil atX: myX Y: myY];

   myX = newX;
   myY = newY;

   [myWorld putObject: self atX: myX Y: myY];

   return self;
}

//
// These are stolen directly from Repast's toroid space
//
- (int) xnorm: (int) x
{
    if((x > worldSizeX - 1) || (x < 0)) 
    {
        while(x < 0)
        {
            x += worldSizeX;
        }

        return x % worldSizeX;
    }

    return x;
}

- (int) ynorm: (int) y
{
    if((y > worldSizeY - 1) || (y < 0)) 
    {
           while(y < 0) 
           {
               y += worldSizeY;
           }

           return y % worldSizeY;
    }

    return y;
}



////////////////////////////////////
//
// grow
//
///////////////////////////////////
- grow
{
    mySize += 1.0;
    return self;
}

@end
