#import "HabitatCell.h"

@implementation HabitatCell 

+ create: aZone
{
    HabitatCell* habitatCell = [super createBegin: aZone];

    habitatCell->myX = -1;
    habitatCell->myY = -1;
    habitatCell->cellFoodAvailable = -1;
    habitatCell->cellMaxFoodProdRate = -1;
    habitatCell->myBug = nil;

    return habitatCell;
}


- setMyX: (int) anX
{
   myX = anX;
   return self;
}

- (int) getMyX
{
    return myX;
}

- setMyY: (int)  aY 
{
   myY = aY;
   return self;
}

- (int) getMyY
{
    return myY;
}
	


- setCellFoodAvailable: (double) aCellFoodAvailable 
{
    cellFoodAvailable = aCellFoodAvailable;
    return self;
}

- (double)  getCellFoodAvailable
{
    return cellFoodAvailable;
}

- setCellMaxFoodProdRate: (double) aCellMaxFoodProdRate
{
    cellMaxFoodProdRate = aCellMaxFoodProdRate;
    return self;
}

- (double) getCellMaxFoodProdRate 
{
    return cellMaxFoodProdRate;
}


- setMyBug: (StupidBug *) aBug
{
   myBug = aBug;
   return self;
}


- (StupidBug *) getMyBug
{
    return myBug;
}



	
////////////////////////////////////
//
// drawSelfOn
//
////////////////////////////////////
- drawSelfOn: (id <Raster>)  aRaster 
{
   if(myBug != nil) 
   {
      [myBug drawSelfOn: aRaster];
   }

   return self;
}

	
///////////////////////////////////
//
// growFood
//
////////////////////////////////////
- growFood
{
   cellFoodAvailable += [uniformDblRand getDoubleWithMin: 0.0 withMax: cellMaxFoodProdRate];

   return self;
}



@end

